; read in Gadget2 snapshot file
;-----------------------------------------------------------------------   

fnam=firstdump
  
for index=0,ndumps-1 do begin

  npart=lonarr(6)	
  massarr=dblarr(6)
  time=0.0D
  redshift=0.0D
  flag_sfr=0L
  flag_feedback=0L
  npartTotal=lonarr(6)	
  flag_cooling = 0L
  num_files = 0L
  BoxSize = 0.D0
  Omega0 = 0.D0
  OmegaLambda = 0.D0
  HubbleParam = 0.D0
  flag_age = 0L
  flag_metals = 0L
  bytesleft=256-6*4 - 6*8 - 8 - 8 - 2*4 - 6*4 - 4 - 4 - 8 - 8 - 8 - 8 - 4 - 4
  la=intarr(bytesleft/2)
  
  fnams=pathn+'snap_'+ifile+string(fnam)
  
  print,'Reading dump',fnams
  openr,1,fnams,/f77_unformatted ;,/swap_endian
  readu,1,npart,massarr,time,redshift,flag_sfr,flag_feedback,npartTotal, $
        flag_cooling,num_files,BoxSize,Omega0,OmegaLambda,HubbleParam,flag_age,flag_metals,la

  print, 'Time [code units]: ', time
  time = time * TimeUnit        ;give units to time
  massarr = massarr * MassUnit  ;give units to mass
  print,"Time [Gyr]= ", time
  
  
  N=total(npart,/PRESERVE_TYPE)
  pos=fltarr(3,N)
  vel=fltarr(3,N)
  id=lonarr(N)
  
  ind=where((npart gt 0) and (massarr eq 0)) 
  if ind(0) ne -1 then begin
     Nwithmass= total(npart(ind))
     mass=fltarr(Nwithmass)
  endif else begin	
     Nwithmass= 0
  endelse
  
  readu,1,pos
  pos = pos * LengthUnit        ;give units to position
  readu,1,vel
  vel = vel * VelUnit           ;give units to velocity
  readu,1,id
  if Nwithmass gt 0 then begin
     readu,1,mass
     mass = mass * MassUnit;give units to mass
  endif
  
  NGas=npart(0)
  NHalo=npart(1)
  NDisk=npart(2)
  NBulge=npart(3)
  NStars=npart(4)
  NBH=npart(5)
  

  if Ngas gt 0l then begin
     
     u=fltarr(Ngas)
     readu,1,u
     u = u * SpecEnergyUnit     ;give units to internal energy per unit mass 
    
     rho=fltarr(Ngas)
     readu,1,rho
     rho = rho * DensityUnit    ;give units to mass density
     
     nelec=fltarr(Ngas);if cooling
     readu,1,nelec
     
     nh=fltarr(Ngas);if cooling
     readu,1,nh
     
     hsml=fltarr(Ngas)
     readu,1,hsml
     hsml = hsml * LengthUnit ;give units to SPH smoothing length

     sfr_rate=fltarr(Ngas);if SF
     readu,1,sfr_rate; we don't give units to SFR
     
  endif


  if Nstars gt 0 then begin ;if stellarage

    age=fltarr(Nstars)
    readu,1,age
    age = age * TimeUnit ;give units to age of stars
    stellarages=fltarr(Nstars) & stellarages=time-age
    ida = where(stellarages le dtime, acount)
    if (acount ne 0) then print, 'Number of stars younger than ', dtime, ' Gyr: ', acount, ' out of total ', nstars, ' stars.'
 endif else ida=0.

  if NBH gt 0 then begin
     
     BH_mass=fltarr(NBH)
     readu,1,BH_mass
     BH_mass = BH_mass * MassUnit ;give scale and unit to BH masses
     
     BH_mdot=fltarr(NBH)
     readu,1,BH_mdot
     BH_mdot = BH_mdot * SFRUnit ;give scale and unit to BH accretion rate                
  endif  

  pot = fltarr(N) ;if OUTPUTPOTENTIAL
  readu,1,pot
  pot = pot * SpecEnergyUnit    ;give units to potential



  if Ngas gt 0 then begin     
          
     ;; dtEntropy=fltarr(Ngas);if OUTPUTCHANGEOFENTROPY
     ;; readu,1,dtEntropy
     ;; dtEntropy = dtEntropy * DtEntropyUnit ;give scale and unit to change of entropic function

     pressure = fltarr(Ngas)    ;if OUTPUTPRESSURE
     readu,1,pressure
     pressure = pressure * PressureUnit ;give scale and unit to pressure
     
     ;; dtU=fltarr(Ngas)           ;if OUTPUTCHANGEOFINTERNALENERGY
     ;; readu,1,dtU
     ;; dtU = dtU * DtSpecEnergyUnit ;give scale and unit to change of specific internal energy

  endif

; find new dump file extension
  fnam0 = fnam
     fnam=fnam+1
     IF (fnam lt 10) THEN BEGIN
        fnam=string(format='(i1)',fnam)
        fnam='00'+fnam
     ENDIF
     IF ((fnam lt 100) and (fnam gt 9)) THEN BEGIN
        fnam=string(format='(i2)',fnam)
        fnam='0'+fnam
     ENDIF
     
     IF ((fnam lt 1000) and (fnam gt 99)) THEN BEGIN
        fnam=string(format='(i3)',fnam)
     ENDIF

  close,1
;-----------------------------------------------------------------------
; rotate particles
pi=4.*atan(1.)
phimod=2.0d0*pi*phi/360.0d0
thetmod=2.0d0*pi*thet/360.0d0
psimod=2.0d0*pi*psi/360.0d0

costhet=COS(thetmod)
sinthet=SIN(thetmod)
cosphi=COS(phimod)
sinphi=SIN(phimod)
cospsi=COS(psimod)
sinpsi=SIN(psimod)


posold=fltarr(3,N)
posold=pos

;matrix elements
aR =dblarr(3,3)
aR(0,0)=cosphi*cospsi
aR(0,1)=cosphi*sinpsi*sinthet+sinphi*costhet
aR(0,2)=-cosphi*sinpsi*costhet+sinphi*sinthet
aR(1,0)=-sinphi*cospsi
aR(1,1)=-sinphi*sinpsi*sinthet+cosphi*costhet
aR(1,2)=sinphi*sinpsi*costhet+cosphi*sinthet
aR(2,0)=sinpsi
aR(2,1)=-cospsi*sinthet
aR(2,2)=cospsi*costhet

         pos(0,*) = posold(0,*)*aR(0,0)+posold(1,*)*aR(0,1)+posold(2,*)*aR(0,2)
         pos(1,*) = posold(0,*)*aR(1,0)+posold(1,*)*aR(1,1)+posold(2,*)*aR(1,2)
         pos(2,*) = posold(0,*)*aR(2,0)+posold(1,*)*aR(2,1)+posold(2,*)*aR(2,2)


velold=fltarr(3,N)
velold=vel

         vel(0,*) = velold(0,*)*aR(0,0)+velold(1,*)*aR(0,1)+velold(2,*)*aR(0,2)
         vel(1,*) = velold(0,*)*aR(1,0)+velold(1,*)*aR(1,1)+velold(2,*)*aR(1,2)
         vel(2,*) = velold(0,*)*aR(2,0)+velold(1,*)*aR(2,1)+velold(2,*)*aR(2,2)

;------------------------------------------------------------------------

  mcount = 0l

  if Ngas gt 0 then begin
     xgas=fltarr(Ngas) &  ygas=fltarr(Ngas)  & zgas=fltarr(Ngas) & mgas=fltarr(Ngas)
     vxgas=fltarr(Ngas) &  vygas=fltarr(Ngas)  & vzgas=fltarr(Ngas) & met_gas=fltarr(4,ngas)
     xgas(*)=pos(0,0:Ngas-1)
     ygas(*)=pos(1,0:Ngas-1)
     zgas(*)=pos(2,0:Ngas-1)
     vxgas(*)=vel(0,0:Ngas-1)
     vygas(*)=vel(1,0:Ngas-1)
     vzgas(*)=vel(2,0:Ngas-1)
     if massarr(0) eq 0 then begin
;        mgas(*)=mass(0L:Ngas-1L)	
        mgas(*)=mass(mcount:mcount+Ngas-1L)
        mcount=mcount+Ngas
     endif else begin
        mgas(*)= massarr(0)
     endelse
  endif    

  
  if Nhalo gt 0 then begin
     xhalo=fltarr(NHalo) &  yhalo=fltarr(Nhalo) & zhalo=fltarr(Nhalo) & mhalo=fltarr(Nhalo)
     vxhalo=fltarr(NHalo) &  vyhalo=fltarr(Nhalo) & vzhalo=fltarr(Nhalo)
     xhalo(*)=pos(0,0+Ngas:Nhalo+Ngas-1)
     yhalo(*)=pos(1,0+Ngas:Nhalo+Ngas-1)
     zhalo(*)=pos(2,0+Ngas:Nhalo+Ngas-1)
     vxhalo(*)=vel(0,0+Ngas:Nhalo+Ngas-1)
     vyhalo(*)=vel(1,0+Ngas:Nhalo+Ngas-1)
     vzhalo(*)=vel(2,0+Ngas:Nhalo+Ngas-1)
     if massarr(1) eq 0 then begin
;        mhalo(*)=mass(0L+Ngas:Ngas+Nhalo-1L)	
        mhalo(*)=mass(mcount:mcount+Nhalo-1L)
        mcount=mcount+Nhalo
     endif else begin
        mhalo(*)= massarr(1)
     endelse
  endif

  
  if Ndisk gt 0 then begin
     xdisk=fltarr(NDisk) &  ydisk=fltarr(NDisk) &  zdisk=fltarr(NDisk) & mdisk=fltarr(NDisk)
     vxdisk=fltarr(NDisk) &  vydisk=fltarr(NDisk) &  vzdisk=fltarr(NDisk); & met_disk=fltarr(4,NDisk)
     xdisk(*)=pos(0,Nhalo+Ngas:Nhalo+Ndisk+Ngas-1)
     ydisk(*)=pos(1,Nhalo+Ngas:Nhalo+Ndisk+Ngas-1)
     zdisk(*)=pos(2,Nhalo+Ngas:Nhalo+Ndisk+Ngas-1)
     vxdisk(*)=vel(0,Nhalo+Ngas:Nhalo+Ndisk+Ngas-1)
     vydisk(*)=vel(1,Nhalo+Ngas:Nhalo+Ndisk+Ngas-1)
     vzdisk(*)=vel(2,Nhalo+Ngas:Nhalo+Ndisk+Ngas-1)
     if massarr(2) eq 0 then begin
;        mdisk(*)=mass(0L+Ngas+Nhalo:Ngas+Nhalo+Ndisk-1L)	
        mdisk(*)=mass(mcount:mcount+Ndisk-1L)
        mcount=mcount+Ndisk
     endif else begin
        mdisk(*)= massarr(2)
     endelse
  endif

  
  if Nbulge gt 0 then begin
     xbulge=fltarr(NBulge) &  ybulge=fltarr(NBulge) &  zbulge=fltarr(NBulge) & mbulge=fltarr(NBulge)
     vxbulge=fltarr(NBulge) &  vybulge=fltarr(NBulge) &  vzbulge=fltarr(NBulge); & met_bulge=fltarr(4,NBulge)
     xbulge(*)=pos(0,Nhalo+Ndisk+Ngas:Nhalo+Ndisk+Ngas+Nbulge-1)
     ybulge(*)=pos(1,Nhalo+Ndisk+Ngas:Nhalo+Ndisk+Ngas+Nbulge-1)
     zbulge(*)=pos(2,Nhalo+Ndisk+Ngas:Nhalo+Ndisk+Ngas+Nbulge-1)
     vxbulge(*)=vel(0,Nhalo+Ndisk+Ngas:Nhalo+Ndisk+Ngas+Nbulge-1)
     vybulge(*)=vel(1,Nhalo+Ndisk+Ngas:Nhalo+Ndisk+Ngas+Nbulge-1)
     vzbulge(*)=vel(2,Nhalo+Ndisk+Ngas:Nhalo+Ndisk+Ngas+Nbulge-1)
     if massarr(3) eq 0 then begin
;        mbulge(*)=mass(0L+Ngas+Nhalo+Ndisk:Ngas+Nhalo+Ndisk+Nbulge-1L)	
        mbulge(*)=mass(mcount:mcount+Nbulge-1L)	
        mcount=mcount+Nbulge
     endif else begin
        mbulge(*)= massarr(3)
     endelse
  endif

    
  if Nstars gt 0 then begin
     xstars=fltarr(Nstars) &  ystars=fltarr(Nstars)  & zstars=fltarr(Nstars)  & mstars=fltarr(Nstars)
     vxstars=fltarr(Nstars) &  vystars=fltarr(Nstars)  & vzstars=fltarr(Nstars); & met_stars=fltarr(4,Nstars)
     xstars(*)=pos(0,Nhalo+Ngas+Ndisk+Nbulge:Nhalo+Ndisk+Ngas+NBulge+Nstars-1)
     ystars(*)=pos(1,Nhalo+Ngas+Ndisk+Nbulge:Nhalo+Ndisk+Ngas+Nbulge+Nstars-1)
     zstars(*)=pos(2,Nhalo+Ngas+Ndisk+Nbulge:Nhalo+Ndisk+Ngas+NBulge+Nstars-1)
     vxstars(*)=vel(0,Nhalo+Ngas+Ndisk+Nbulge:Nhalo+Ndisk+Ngas+NBulge+Nstars-1)
     vystars(*)=vel(1,Nhalo+Ngas+Ndisk+Nbulge:Nhalo+Ndisk+Ngas+Nbulge+Nstars-1)
     vzstars(*)=vel(2,Nhalo+Ngas+Ndisk+Nbulge:Nhalo+Ndisk+Ngas+NBulge+Nstars-1)
     if massarr(4) eq 0 then begin
;        mstars(*)=mass(0L+Ngas+Nhalo+Ndisk+Nbulge:Ngas+Nhalo+Ndisk+Nbulge+Nstars-1L)	
        mstars(*)=mass(mcount:mcount+Nstars-1L)	
        mcount=mcount+Nstars
     endif else begin
        mstars(*)= massarr(4)
     endelse
  endif

  
  if NBH gt 0 then begin         
     xBH=fltarr(NBH) &  yBH=fltarr(NBH)  & zBH=fltarr(NBH)  & mBH=fltarr(NBH)
     vxBH=fltarr(NBH) &  vyBH=fltarr(NBH)  & vzBH=fltarr(NBH)
     xBH(*)=pos(0,Nhalo+Ngas+Ndisk+Nbulge+Nstars:Nhalo+Ndisk+Ngas+NBulge+Nstars+NBH-1)
     yBH(*)=pos(1,Nhalo+Ngas+Ndisk+Nbulge+Nstars:Nhalo+Ndisk+Ngas+Nbulge+Nstars+NBH-1)
     zBH(*)=pos(2,Nhalo+Ngas+Ndisk+Nbulge+Nstars:Nhalo+Ndisk+Ngas+NBulge+Nstars+NBH-1)
     vxBH(*)=vel(0,Nhalo+Ngas+Ndisk+Nbulge+Nstars:Nhalo+Ndisk+Ngas+NBulge+Nstars+NBH-1)
     vyBH(*)=vel(1,Nhalo+Ngas+Ndisk+Nbulge+Nstars:Nhalo+Ndisk+Ngas+Nbulge+Nstars+NBH-1)
     vzBH(*)=vel(2,Nhalo+Ngas+Ndisk+Nbulge+Nstars:Nhalo+Ndisk+Ngas+NBulge+Nstars+NBH-1)
     if massarr(5) eq 0 then begin
;        mBH(*)=mass(0L+Ngas+Nhalo+Ndisk+Nbulge+Nstars:Ngas+Nhalo+Ndisk+Nbulge+Nstars+NBH-1L)	
        mBH(*)=mass(mcount:mcount+NBH-1L)	
        mcount=mcount+NBH
     endif else begin
        mBH(*)= massarr(5)
     endelse
  endif
print, 'totalSFR [Msun*yr^-1]= ', total(sfr_rate)

;plotting
;CloseUps
if doCloseUp gt 0 then plot_CloseUps, xgas,ygas, xhalo,yhalo, xdisk,ydisk, xbulge,ybulge, xstars,ystars, $
                                      ida, Range, displaygas, displayhalo, displaydisk, displaybulge, displaystars,$
                                      dooplotnewstars, thet, psi, phi, pathn, dtime, doCloseUp, fnam0, TIME=time

endfor ;MAIN LOOP

end
