;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Produce a plot of the inner region of a merger near   ;;
;; second pericenter                                     ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PRO plot_CloseUps, xgas,ygas, xhalo,yhalo, xdisk,ydisk, xbulge,ybulge, xstars,ystars, $
                   ida, Range, displaygas, displayhalo, displaydisk, displaybulge, displaystars,$
                   dooplotnewstars, thet, psi, phi, pathn, dtime, doCloseUp, fnam, TIME=time, CoM=xCoM, ROT=idoRot


fname_closeup=pathn+'CloseUp_Range'+strtrim(Range,2)
if keyword_set(idoRot) then begin
fname_closeup=fname_closeup+'_th_'+strtrim(floor(thet),2)+'_psi_'+strtrim(floor(psi),2)+'_phi_'+strtrim(floor(phi),2)
endif
if dooplotnewstars ne 0 then fname_closeup=fname_closeup +'_dtage'+strtrim(dtime,2)

;plotting
;----------
!p.multi=[0,1,1]
!x.margin=[10,3]
!x.omargin=[0,0]
!x.style=1
!y.style=1
if doCloseUp ge 3 then begin
   set_plot,'ps'
   print, 'printing... ps'
   device, xsize=8.75, ysize=8, filename=fname_closeup+'_'+strtrim(fnam,2)+'.eps',/color,bits=8,/Encapsulated
   !p.charsize=.5
   !p.thick=.8
   setsym = 1.
   ncolor = 0.
endif else begin
   set_plot, 'x'
   wSize = GET_SCREEN_SIZE()
   window,10,xsize=wSize[0]*0.5,ysize=wSize[0]*0.5
   setsym=3.5
   ncolor=0
   wset,10
   !p.charsize=1.5
   !p.thick=1.5
endelse
xtit='!N!6x!D!N!6 [kpc]'
ytit='!N!6y!D!N!6 [kpc]'
!x.title=xtit
!y.title=ytit
plotsym, 0 ,/fill
loadct,39


 plot, xgas,ygas,psym=3,xr=[-Range,Range],yr=[-Range,Range],/nodata,title='',/iso,background=255,color=0
 if displayhalo then oplot,xhalo,yhalo,psym=3,color=50
 if displaydisk then oplot,xdisk,ydisk,psym=3,color=150
 if displaybulge then oplot,xbulge,ybulge,psym=3,color=30
 if displaygas then oplot,xgas,ygas,psym=3, color=245;150;80
 if displaystars then if(nstars gt 0) then oplot,xstars,ystars,psym=3,color=240
 ;plots,(xbh(*)),(ybh(*)),psym=4,color=60,symsize=2
 if dooplotnewstars ne 0 and ida(0) ne -1 then begin
     print, 'newstars',n_elements(ida)
     oplot, xstars(ida),ystars(ida),psym=1,symsize=setsym,color=ncolor
     xyouts, 0.75, 0.2, '#: '+strtrim(N_elements(ida),2), color=ncolor, /normal
 endif
 if keyword_set(xCoM) then begin
     plots, xCoM(0), xCoM(1), psy=1, symsize=3, color=0
 endif

 if keyword_set(time) then begin
     xyouts, 0.67, 0.87, 'time/dump= '+strtrim(time,2)+'/'+strtrim(fnam,2), color=ncolor, /normal
 endif
if doCloseUp ge 3 then begin
   device, /close
   set_plot, 'x'
endif
if doCloseUp eq 2 then write_png,fname_closeup+'_'+strtrim(fnam,2)+".png",TVRD(/true)

;stop
return
end
